window.Gleam.initSearch([{"doc":"illustrious","title":"illustrious","content":"# illustrious\n\n[![Package Version](https://img.shields.io/hexpm/v/illustrious)](https://hex.pm/packages/illustrious)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/illustrious/)\n\n```sh\ngleam add illustrious\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/illustrious&gt;.\n\n## Development\n\n```sh\n# Requires GNU Make\ncd examples/basic &amp;&amp; make # Builds the client and starts the server\n```\n","url":"index.html"},{"doc":"illustrious/state","title":"Decoder","content":"pub type Decoder(action) =\n  fn(Dynamic) -&gt;\n    Result(IllustriousAction(action), dynamic.DecodeErrors)\n The decoder function which takes in a JSON-decoded dynamic from the\n initializer or server loader and returns an effect which can be executed in\n order to populate the application state before rendering\n\nSynonyms:\nillustrious/state.Decoder\nillustrious/state Decoder","url":"illustrious/state.html#Decoder"},{"doc":"illustrious/state","title":"IllustriousAction","content":"pub type IllustriousAction(orig_action) {\n  Perform(orig_action)\n  GoTo(path: String)\n  Redirect(path: String)\n  Back\n  Forward\n  SetPath(parsed_path: Path)\n  Noop\n  All(List(IllustriousAction(orig_action)))\n}\n The internal action/message type which is used by the illustrious application.\nPerform(orig_action)\n\n\nGoTo(path: String)\n\n\nRedirect(path: String)\n\n\nBack\n\n\nForward\n\n\nSetPath(parsed_path: Path)\n\n\nNoop\n\n\nAll(List(IllustriousAction(orig_action)))\n\n\nSynonyms:\nillustrious/state.IllustriousAction\nillustrious/state IllustriousAction","url":"illustrious/state.html#IllustriousAction"},{"doc":"illustrious/state","title":"IllustriousModel","content":"pub type IllustriousModel(model) {\n  IllustriousModel(route: Path, inner_model: model)\n}\n The internal state/model which is used by the illustrious application to\n track its own route state as well as your own state.\nIllustriousModel(route: Path, inner_model: model)\n\n\nSynonyms:\nillustrious/state.IllustriousModel\nillustrious/state IllustriousModel","url":"illustrious/state.html#IllustriousModel"},{"doc":"illustrious/state","title":"Path","content":"pub type Path =\n  List(String)\n The application path, split by each directory separator (`/`)\n\nSynonyms:\nillustrious/state.Path\nillustrious/state Path","url":"illustrious/state.html#Path"},{"doc":"illustrious/state","title":"Updater","content":"pub type Updater(model, action) =\n  fn(model, action) -&gt;\n    #(model, Effect(IllustriousAction(action)))\n The updater function takes in the current application state and an action\n and returns the new application state and an effect (possibly the `none`\n effect) which get executed\n\nSynonyms:\nillustrious/state.Updater\nillustrious/state Updater","url":"illustrious/state.html#Updater"},{"doc":"illustrious/state","title":"illustrious/state","content":"","url":"illustrious/state.html"},{"doc":"illustrious","title":"Decoder","content":"pub type Decoder(action) =\n  fn(Dynamic) -&gt; Effect(IllustriousAction(action))\n The decoder function which takes in a JSON-decoded dynamic from the\n initializer or server loader and returns an effect which can be executed in\n order to populate the application state before rendering\n\nSynonyms:\nillustrious.Decoder\nillustrious Decoder","url":"illustrious.html#Decoder"},{"doc":"illustrious","title":"Path","content":"pub type Path =\n  state.Path\n The path portion of a URL, split by each directory separator (`/`)\n\nSynonyms:\nillustrious.Path\nillustrious Path","url":"illustrious.html#Path"},{"doc":"illustrious","title":"Router","content":"pub type Router(state, action) =\n  fn(Path, state) -&gt; Option(Element(IllustriousAction(action)))\n The router function takes in the split path &amp; the app state and returns the\n actual elements to render, or None if there is nothing to render (404)\n\nSynonyms:\nillustrious.Router\nillustrious Router","url":"illustrious.html#Router"},{"doc":"illustrious","title":"Updater","content":"pub type Updater(state, action) =\n  fn(state, action) -&gt;\n    #(state, Effect(IllustriousAction(action)))\n The updater function takes in the current application state and an action\n and returns the new application state and an effect (possibly the `none`\n effect) which get executed\n\nSynonyms:\nillustrious.Updater\nillustrious Updater","url":"illustrious.html#Updater"},{"doc":"illustrious","title":"View","content":"pub type View(model, action) =\n  fn(Path, model) -&gt; element.Element(IllustriousAction(action))\n\n\nSynonyms:\nillustrious.View\nillustrious View","url":"illustrious.html#View"},{"doc":"illustrious","title":"illustrious","content":" Illustrious is a meta framework built on top of lustre.  It supports:\n * server-side rendering\n * turning into a SPA by using client-side routing after initial load\n * automatic data hydration when a page is first loaded &amp; on navigation","url":"illustrious.html"},{"doc":"illustrious/client","title":"ClientAppBuilder","content":"pub type ClientAppBuilder(context, model, action) {\n  ClientAppBuilder(\n    view: illustrious.View(model, action),\n    default_model: model,\n    updater: state.Updater(model, action),\n    decoder: state.Decoder(action),\n  )\n}\n The options necessary to initialize the client-side lustre app\nClientAppBuilder(\n  view: illustrious.View(model, action),\n  default_model: model,\n  updater: state.Updater(model, action),\n  decoder: state.Decoder(action),\n)\n\nview\n&lt;p&gt;The function which takes in the application from the path and model,\nand renders the application&lt;/p&gt;\n\ndefault_model\n&lt;p&gt;The initial application state before any baked data is processed&lt;/p&gt;\n\nupdater\n&lt;p&gt;The function used to update application state based on the previous\nmodel and an action being performed&lt;/p&gt;\n\ndecoder\n&lt;p&gt;The function which transforms a JSON payload (in the form of\ninitializer data or page loader data)&lt;/p&gt;\n\nSynonyms:\nillustrious/client.ClientAppBuilder\nillustrious/client ClientAppBuilder","url":"illustrious/client.html#ClientAppBuilder"},{"doc":"illustrious/client","title":"back","content":"pub fn back() -&gt; IllustriousAction(a)\n Used to pop the latest route off the browser&#39;s history stack\n (equivalent to hitting the back button in the browser).\nSynonyms:\nillustrious/client.back\nillustrious/client back","url":"illustrious/client.html#back"},{"doc":"illustrious/client","title":"build_app","content":"pub fn build_app(\n  builder: ClientAppBuilder(a, b, c),\n) -&gt; App(d, IllustriousModel(b), IllustriousAction(c))\n Initializes the client-side lustre app in the browser\nSynonyms:\nillustrious/client.build_app\nillustrious/client build_app","url":"illustrious/client.html#build_app"},{"doc":"illustrious/client","title":"forward","content":"pub fn forward() -&gt; IllustriousAction(a)\n Used to push the next route back onto the browser&#39;s history stack\n (equivalent to hitting the forward button in the browser).\nSynonyms:\nillustrious/client.forward\nillustrious/client forward","url":"illustrious/client.html#forward"},{"doc":"illustrious/client","title":"go_to","content":"pub fn go_to(route: String) -&gt; IllustriousAction(a)\n Used to push a new route into the browser&#39;s history stack.\nSynonyms:\nillustrious/client.go_to\nillustrious/client go_to","url":"illustrious/client.html#go_to"},{"doc":"illustrious/client","title":"perform","content":"pub fn perform(action: a) -&gt; IllustriousAction(a)\n Used to dispatch an action to your own internal state.\nSynonyms:\nillustrious/client.perform\nillustrious/client perform","url":"illustrious/client.html#perform"},{"doc":"illustrious/client","title":"redirect","content":"pub fn redirect(route: String) -&gt; IllustriousAction(a)\n Used to replace the current route in the browser&#39;s history.\nSynonyms:\nillustrious/client.redirect\nillustrious/client redirect","url":"illustrious/client.html#redirect"},{"doc":"illustrious/client","title":"illustrious/client","content":"","url":"illustrious/client.html"},{"doc":"illustrious/link","title":"link","content":"pub fn link(\n  href: String,\n  attributes: List(Attribute(IllustriousAction(a))),\n  content: List(Element(IllustriousAction(a))),\n) -&gt; Element(IllustriousAction(a))\n Creates an `&lt;a&gt;` element which hooks into the history api.  Clicking\n on the element will not cause a full page refresh but instead will push\n a new element onto the history stack.\nSynonyms:\nillustrious/link.link\nillustrious/link link","url":"illustrious/link.html#link"},{"doc":"illustrious/link","title":"illustrious/link","content":"","url":"illustrious/link.html"},{"doc":"illustrious/server","title":"Initializer","content":"pub type Initializer(context, error) =\n  fn(Path, context) -&gt; Result(Json, error)\n The initializer function takes in the path &amp; the app state and returns a\n JSON value which can be serialized and sent to the client to initialize\n the application state before the first client render\n\nSynonyms:\nillustrious/server.Initializer\nillustrious/server Initializer","url":"illustrious/server.html#Initializer"},{"doc":"illustrious/server","title":"ServerApp","content":"pub opaque type ServerApp(context, model, action, error)\n A generated server-side application\n\nSynonyms:\nillustrious/server.ServerApp\nillustrious/server ServerApp","url":"illustrious/server.html#ServerApp"},{"doc":"illustrious/server","title":"ServerAppBuilder","content":"pub type ServerAppBuilder(context, model, action, error) {\n  ServerAppBuilder(\n    view: illustrious.View(model, action),\n    html_headers: illustrious.View(model, action),\n    default_model: model,\n    updater: state.Updater(model, action),\n    decoder: state.Decoder(action),\n    initializer: Initializer(context, error),\n    loader: ServerLoader(context, error),\n    error_serializer: fn(error) -&gt; String,\n  )\n}\n The options necessary to initialize the client-side lustre app\nServerAppBuilder(\n  view: illustrious.View(model, action),\n  html_headers: illustrious.View(model, action),\n  default_model: model,\n  updater: state.Updater(model, action),\n  decoder: state.Decoder(action),\n  initializer: Initializer(context, error),\n  loader: ServerLoader(context, error),\n  error_serializer: fn(error) -&gt; String,\n)\n\nview\n&lt;p&gt;The function which takes in the application from the path and model,\nand renders the application&lt;/p&gt;\n\nhtml_headers\n&lt;p&gt;A view of html headers.  Used to render inside the &lt;code&gt;&amp;lt;head&amp;gt;&lt;/code&gt; tag during\nserver-side rendering.&lt;/p&gt;\n\ndefault_model\n&lt;p&gt;The initial application state before any baked data is processed&lt;/p&gt;\n\nupdater\n&lt;p&gt;The function used to update application state based on the previous\nmodel and an action being performed&lt;/p&gt;\n\ndecoder\n&lt;p&gt;The function which transforms a JSON payload (in the form of\ninitializer data or page loader data)&lt;/p&gt;\n\ninitializer\n&lt;p&gt;The function called when a page is first loaded, which takes in the\napplication path and context, in order to initialize the application\nstate.&lt;/p&gt;\n&lt;p&gt;Returns a Result containing a Json object (or a Json array of\nobjects) which can be deserialized using the &lt;code&gt;decoder&lt;/code&gt; and applied in\norder to the app state using the &lt;code&gt;updater&lt;/code&gt; to generate the initial\napplication state upon first loading a route.&lt;/p&gt;\n&lt;p&gt;If the Result is instead an &lt;code&gt;Error&lt;/code&gt;, the contained error is serialized\ninto a string using the &lt;code&gt;error_serializer&lt;/code&gt; function.&lt;/p&gt;\n\nloader\n&lt;p&gt;The function called whenever a route change occurs, which takes in the\napplication path and context, in order to send data to the client to\nupdate its state.&lt;/p&gt;\n&lt;p&gt;Returns a Result containing a Json object (or a Json array of\nobjects) which can be deserialized using the &lt;code&gt;decoder&lt;/code&gt; and applied in\norder to the app state using the &lt;code&gt;updater&lt;/code&gt; to generate the new\napplication state upon changing to a new route.&lt;/p&gt;\n&lt;p&gt;If the Result is instead an &lt;code&gt;Error&lt;/code&gt;, the contained error is serialized\ninto a string using the &lt;code&gt;error_serializer&lt;/code&gt; function.&lt;/p&gt;\n\nerror_serializer\n&lt;p&gt;A function which takes in any errors generated by the &lt;code&gt;initializer&lt;/code&gt; or\n&lt;code&gt;loader&lt;/code&gt; functions and returns a &lt;code&gt;String&lt;/code&gt;&lt;/p&gt;\n\nSynonyms:\nillustrious/server.ServerAppBuilder\nillustrious/server ServerAppBuilder","url":"illustrious/server.html#ServerAppBuilder"},{"doc":"illustrious/server","title":"ServerLoader","content":"pub type ServerLoader(context, error) =\n  fn(Path, context) -&gt; Result(Json, error)\n The server loader function takes in the path and returns a JSON value which\n can be used to populate the server state and also serialized and sent to\n the client in order to initialize the state there as well\n\nSynonyms:\nillustrious/server.ServerLoader\nillustrious/server ServerLoader","url":"illustrious/server.html#ServerLoader"},{"doc":"illustrious/server","title":"ServerResult","content":"pub type ServerResult(action) {\n  View(element.Element(IllustriousAction(action)))\n  Data(Json)\n  ServerError(String)\n  NoResult\n}\n The result of calling a `ServerApp`&#39;s `request_handler` function.\nView(element.Element(IllustriousAction(action)))\n The type of result which comes from the request matching a page route.\n\nData(Json)\n The type of result sent whenever a request comes in that calls the app&#39;s\n `loader` function, which gets sent to the client to update the model.\n\nServerError(String)\n The type of result which comes from an error occuring during\n initialization, rendering, or loading.\n\nNoResult\n The type of result when no route is matched.\n\nSynonyms:\nillustrious/server.ServerResult\nillustrious/server ServerResult","url":"illustrious/server.html#ServerResult"},{"doc":"illustrious/server","title":"build_app","content":"pub fn build_app(\n  builder: ServerAppBuilder(a, b, c, d),\n) -&gt; ServerApp(a, b, c, d)\n Create a `ServerApp` based on the builder passed in.\nSynonyms:\nillustrious/server.build_app\nillustrious/server build_app","url":"illustrious/server.html#build_app"},{"doc":"illustrious/server","title":"handle_request","content":"pub fn handle_request(\n  app: ServerApp(a, b, c, d),\n  method: Method,\n  path: List(String),\n  body: String,\n  context: a,\n) -&gt; ServerResult(c)\n The function to handle a request sent to the server applicaiton.\nSynonyms:\nillustrious/server.handle_request\nillustrious/server handle_request","url":"illustrious/server.html#handle_request"},{"doc":"illustrious/server","title":"illustrious/server","content":"","url":"illustrious/server.html"}]);